Available in🇮🇳 India
Create a one time mandate on UPI to let your customers block an amount and pay later. The amount gets blocked on the customer’s bank account and can be debited once within the expiry of the mandate. A one time mandate on UPI can help charge customers post-delivery of products or services, helping make the customer experience delightful for businesses like E-commerce, Travel, Transport, Healthcare, and many more.
Example
Gaurav Kumar wants to reserve a room at Acme Hotel. However, he is still determining the travel plan. He wants to pay after check-in.
Using UPI One Time Mandate, Gaurav Kumar can consent to block the hotel booking amount and only let Acme Hotel debit the amount after check-in.
To create a one time mandate:
Create an Authorisation Transaction
You can create an authorisation transaction using the Razorpay APIs or Registration Link.1.1 Using Razorpay APIs
To create an authorisation transaction using the Razorpay APIs, you need to:1.1.1 Create a Customer
Razorpay links a one time mandate token to customers via a unique identifier. You can generate this identifier using the Customer API. You can create customers with basic information such asemail and contact and use them for various Razorpay offerings. The following endpoint creates a customer.
POST /customers
Request Parameters
Request Parameters
name
: string The name of the customer. For example, Gaurav Kumar.email
: string The email address of the customer. For example, gaurav.kumar@example.com.contact
: string The phone number of the customer. For example, 9876543210.fail_existing optional
: string The request throws an exception by default if a customer with the exact details already exists. You can pass an additional parameter fail_existing to get the existing customer’s details in the response. Possible values:1(default): If a customer with the same details already exists, throws an error.0: If a customer with the same details already exists, fetches details of the existing customer.
notes optional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.1.1.2. Create an Order
Use the Orders API to create a unique Razorpayorder_id that is associated with the authorisation transaction for a one time mandate. To create a one-time mandate, pass the value of the frequency parameter as one_time. The following endpoint creates an order.
POST /orders
Request Parameters
Request Parameters
amount mandatory
: integer Amount in currency subunits.currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.customer_id mandatory
: string The unique identifier of the customer. For example, cust_4xbQrmEoA5WJ01.method mandatory
: string The authorisation method. Here, it is upi.receipt optional
: string A user-entered unique identifier of the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notesoptional
: object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.token
: object Details related to the authorisation such as max amount, frequency and expiry information.max_amount mandatory
: integer The maximum amount that can be debited in a single charge.For other categories and MCCs, the minimum value is
100 (₹1) and maximum value is 9999900 (₹99,999).expire_at mandatory
: integer The Unix timestamp at which the authorisation transaction expires. For insurance MCCs (6300, 5960, 6529), the maximum validity is 14 days. For all other MCCs, the maximum validity is 30 years.frequency mandatory
: string The frequency at which you can charge your customer. The value should be one_time for one time mandate.1.1.3. Create an Authorisation Payment
After you create an order, you should create a payment. This is a dummy transaction that fails with an errorBAD_REQUEST_ERROR when a customer tries to approve the mandate request from a PSP application. A token is created and marked as confirmed for the same.
The UPI payment flow you use determines how the customer approves the mandate:
- UPI Intent (recommended): The customer is redirected to their preferred UPI app to approve the mandate. This is the default flow.
- UPI Collect (deprecated): A collect request is sent to the customer’s VPA (UPI ID). This flow is being deprecated for new UPI mandate registrations effective 28 February 2026. For iOS users, you may continue to use the Collect flow as a fallback.
Handy TipsYou will get the token.confirmed webhook after the customer approves the mandate request.
POST /payments/create/upi
Sample Code
Sample Code
UPI Intent
UPI Intent
UPI Collect (Deprecated)
UPI Collect (Deprecated)
Before creating the collect payment, validate the customer’s UPI ID using the Once the UPI ID is validated, create the authorisation payment with
/payments/validate/vpa endpoint.upi.flow set to collect.Request Parameters
Request Parameters
amount mandatory
: integer The amount associated with the payment in the smallest unit of the supported currency. For example, 2000 means ₹20. Must match the amount in Step 1.1.2: Create an Order.currency mandatory
: string The 3-letter ISO currency code for the payment. Currently, we only support INR.order_id mandatory
: string The unique identifier of the order created in Step 1.1.2: Create an Order.email mandatory
: string The customer’s email address. For example, gaurav.kumar@example.com.contact mandatory
: string The customer’s contact number. For example, 9123456780.customer_id mandatory
: string Unique identifier of the customer, obtained from the response of Step 1.1.1: Create a Customer.recurring mandatory
: string Determines if the recurring payment is enabled or not. Possible values:1: Recurring payment is enabled.preferred: Use this if you want to allow recurring payments and one-time payment in the same flow.
method mandatory
: string The payment method selected by the customer. Here, the value must be upi.upi
: object Details of the UPI payment flow.flow mandatory
: string Specify the type of the UPI payment flow. Possible values are:
intent(default, recommended)collect: Deprecated effective 28 February 2026. For iOS users, you may continue to use the Collect flow as a fallback.
vpa mandatory for collect
: string The VPA of the customer where the collect request will be sent. Applicable only to the UPI Collect flow.expiry_time optional
: integer Period of time (in minutes) after which the collect request will expire. The default value is 5. Applicable only to the UPI Collect flow.ip mandatory for collect
: string Client’s browser IP address. For example, 117.217.74.98.referer mandatory for collect
: string Value of referer header passed by the client’s browser. For example, https://example.com/.user_agent mandatory for collect
: string Value of user_agent header passed by the client’s browser. For example, Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/79.0.3945.130 Safari/537.36
description optional
: string Descriptive text of the payment.save optional
: boolean Applicable only to the UPI Collect flow. Specifies if the VPA should be stored as a token. Possible values:true: Saves the VPA details.false(default): Does not save the VPA details.
notes optional
: json object Key-value pairs that can hold additional information about the payment. Refer to the Notes section of the API Reference Guide.
1.2. Using a Registration Link
Registration Links are an alternate way of creating an authorisation transaction. If you create a registration link, you need not create a customer or an order. When you create a registration link, an invoice is automatically issued to the customer. The customer can use the invoice to make the Authorisation Payment.Handy TipsYou can use Token Webhooks to get notifications about successful payments against a registration link. Do not use payment webhooks for Authorisation Payments.
1.2.1. Create a Registration Link
The following endpoint creates a registration link you can share with your customers to make one time mandate payments. This is a dummy transaction that fails with an errorBAD_REQUEST_ERROR when a customer tries to approve the mandate request from a PSP application. A token is created and marked as confirmed for the same.
POST /subscription_registration/auth_links
Request Parameters
Request Parameters
customer
: object Details of the customer to whom the registration link is sent.name mandatory
: string Customer’s name.email mandatory
: string Customer’s email address.contactmandatory
: integer Customer’s contact number.type mandatory
: string In this case, the value is link.amount mandatory
: integer The payment amount in the smallest currency sub-unit.currency mandatory
: string The 3-letter ISO currency code for the payment.description mandatory
: string A description that appears on the hosted page.subscription_registration
: object Details of the authorisation transaction.method mandatory
: string The payment method used to make authorisation transaction. Here, it is card.max_amount mandatory
: integer Use to set the maximum amount (in paise) per debit request.For other categories and MCCs, the minimum value is
100 (₹1) and maximum value is 9999900 (₹99,999).expire_at optional
: integer The Unix timestamp till when you can use the token to charge the customer subsequent payments. The default value is 10 years and the maximum value allowed is 30 years.frequency mandatory
: string The frequency at which you can charge your customer. The value should be one_time for one time mandate.sms_notify optional
: boolean Indicates if SMS notifications are to be sent by Razorpay. Possible values:true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
email_notify optional
: boolean Indicates if email notifications are to be sent by Razorpay. Possible values:true(default): Notifications are sent by Razorpay .false: Notifications are not sent by Razorpay.
expire_by optional
: integer The Unix timestamp indicates the expiry of the registration link.receipt optional
: string A unique identifier entered by you for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notes optional
: object This is a key-value pair that is used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.1.2.2. Send/Resend Notifications
The following endpoint sends/resends notifications with the short URL to the customer:POST /invoices/:id/notify_by/:medium
Sample Code
Sample Code
Response
Path Parameters
Path Parameters
idmandatory
: string The unique identifier of the invoice linked to the registration link for which you want to send the notification. For example, inv_1Aa00000000001.medium mandatory
: string Determines through which medium you want to resend the notification. Possible values:smsemail
1.2.3. Cancel a Registration Link
The following endpoint cancels a registration link.POST /invoices/:id/cancel
Handy TipsYou can only cancel registration link in the
issued state.Sample Code
Sample Code
Response
Path Parameters
Path Parameters
id mandatory
: string The unique identifier for the invoice linked to the registration link that you want to cancel. For example, inv_1Aa00000000001.